unit Unit2;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;
Function GAMMLN(xx:real):real;
Function FACTLN(N:integer):real;
Function BICO(N, K:Integer):real;

implementation
Function GAMMLN(xx:real):real;
CONST
  STP=2.50662827465; HALF=0.5; ONE=1.0; FPF=5.5;
var
  x,tmp,ser:double;
  j:integer;
  cof:array[1..6] of double;
BEGIN
  COF[1]:=76.18009173;      COF[2]:=-86.50532033;
  COF[3]:=24.01409822;      COF[4]:=-1.231739516;
  COF[5]:= 0.120858003e-2;  COF[6]:=-0.536382e-5;
  X:=XX-ONE;
  TMP:=X+FPF;
  TMP:=(X+HALF)*Ln(TMP)-TMP;
  SER:=ONE;
  For J:=1 To 6 do
    BEGIN
      X:=X+ONE;
      SER:=SER+COF[J]/X
    END;
  GAMMLN:=TMP+Ln(STP*SER);
end;

Function FACTLN(N:INTEGER):real;
var
  I:integer;
  A:array[1..100] of real;
begin
    For I:=1 To 100 do
      A[I]:=-1;
    If N < 0 Then  ShowMessage('棺N<0޸ĳ');
    If N <= 99 Then
      begin
        If A[N + 1] < 0 Then A[N + 1]:=GAMMLN(N + 1);
        FACTLN:=A[N + 1];
      end
    Else
      FACTLN:=GAMMLN(N + 1);
end;

Function BICO(N,K:Integer):real;
begin
  BICO:=Int(Exp(FACTLN(N)-FACTLN(K)-FACTLN(N-K)));
end;

end.
