unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;
Function FUNC(X:real):real;
type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
//PROGRAM D5R9
//Driver for routine PCSHFT
uses
  unit2;
  {$R *.DFM}
Function FUNC(X:real):real;
begin
    FUNC:= Sqr(X) * (Sqr(X) - 2) * Sin(X);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  F:TextFile;
  C,D:array[0..40] of real;
  X,Y,POLY:real;  I,J,MVAL:integer;
const
  s1='%13.6f'; s2='##0'; NVAL = 40;
  PIO2 = 1.5707963;
  A = -PIO2;   B = PIO2;
begin
  CHEBFT(A, B, C, NVAL);
  //Test derivative
  //ļ
  AssignFile(F, 'd:\delphi_shu\p5\d5r9.dat');
  Rewrite(F);
  Writeln(F, 'How many terms in Chebyshev evaluation?');
  //Input MVAL , between 6 and 40, MVAL=0 TO END
  MVAL:= 20;
  Writeln(F,FormatFloat(s2,MVAL));
  If (MVAL <= 0) Or (MVAL > NVAL) Then Exit;
  CHEBPC(C,D,MVAL);
  PCSHFT(A,B,D,MVAL);
  Writeln(F, '         X         Actual    Polynomial');
  For I:= -8 To 8 do
  begin
    X:= I * PIO2 / 10;
    POLY:= D[MVAL];
    for J:=MVAL - 1 DownTo 1 do
        POLY:= POLY * X + D[J];
    Writeln(F,Format(s1,[X]),Format(s1,[FUNC(X)]),Format(s1,[POLY]));
  end;
  CloseFile(F);
  //Ļʾ
  memo1.Lines.LoadFromFile('d:\delphi_shu\p5\d5r9.dat');
end;

end.
