unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ISET:^integer; GSET:^real;
implementation
//PROGRAM D7R1
//Driver for routine FIT
uses
  unit2;
{$R *.DFM}
procedure TForm1.Button1Click(Sender: TObject);
const
  s1='%9.6f';
  NPT = 100; SPREAD = 0.5;  
var
    X,Y,SIG:array[0..100] of real;
    F:TextFile;
    I,NWT,MWT:integer; A,B,SIGA,SIGB,CHI2,Q:real;
begin
  New(ISET); New(GSET);
  Iset^:=0; GSET^:=0;
  Randomize;
  For I:=1 To NPT do
  begin
    X[I]:=0.1 * I;
        Y[I]:=-2 * X[I] + 1 + SPREAD * GASDEV;
        SIG[I]:=SPREAD;
  end;
  //ļ
  AssignFile(F, 'd:\delphi_shu\p7\d7r1.dat');
  Rewrite(F);
  Writeln(F);
  For MWT:=0 To 1 do
  begin
    FIT(X, Y, NPT, SIG, MWT, A, B, SIGA, SIGB, CHI2, Q);
    If MWT = 0 Then
    begin
      Writeln(F, 'Ignoring standard deviation ');
      Writeln(F);
    end
    Else
    begin
      Writeln(F);
      Writeln(F, '   Including standard deviation ');
      Writeln(F);
    end;
    Writeln(F,'   A:=',Format(s1,[A]),'    Uncertainty:', Format(S1,[SIGA]));
    Writeln(F,'   B:=',Format(S1,[B]),'    Uncertainty:', Format(S1,[SIGB]));
    Writeln(F, '   Chi-squared:  ', Format(S1,[CHI2]));
    Writeln(F, '   Goodness-of-fit:  ', Format(S1,[Q]));
  end;
  CloseFile(F);
  //Ļʾ
  memo1.Lines.LoadFromFile('d:\delphi_shu\p7\d7r1.dat');
end;
end.
