unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;
type
  matrx2=array of array of real;
type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
//PROGRAM D7R3
//Driver for routine COVSRT
uses
  unit2;
{$R *.DFM}
procedure TForm1.Button1Click(Sender: TObject);
const
  s1='%5.1f';
  MA = 10; MFIT = 5;
var
  COVAR:matrx2;   LISTA:ARRAY[0..5] of integer;
  I,J:integer;    F:TextFile;
begin
  SetLength(COVAR,11,11);
  For I:=1 To MA do
  begin
    For J:=1 To MA do
    begin
      COVAR[I, J]:= 0;
      If (I <= 5) And (J <= 5) Then
          COVAR[I, J]:= I + J - 1;
    end;
  end;
   //ļ
  AssignFile(F, 'd:\delphi_shu\p7\d7r3.dat');
  Rewrite(F);
  Writeln(F,'Original matrix');
  For I:= 1 To MA do
    Writeln(F, Format(s1,[COVAR[I, 1]]), Format(s1,[COVAR[I, 2]]),
      Format(s1,[COVAR[I, 3]]), Format(s1,[COVAR[I, 4]]),
      Format(s1,[COVAR[I, 5]]), Format(s1,[COVAR[I, 6]]),
      Format(s1,[COVAR[I, 7]]), Format(s1,[COVAR[I, 8]]),
      Format(s1,[COVAR[I, 9]]), Format(s1,[COVAR[I, 10]]));
  //Test 1 - spread by 2
  Writeln(F,'Test #1 - Spread by two');
  For I:= 1 To MFIT do
    LISTA[I]:= 2 * I;
  COVSRT(COVAR, MA, MA, LISTA, MFIT);
  For I:= 1 To MA do
    Writeln(F, Format(s1,[COVAR[I, 1]]), Format(s1,[COVAR[I, 2]]),
      Format(s1,[COVAR[I, 3]]), Format(s1,[COVAR[I, 4]]),
      Format(s1,[COVAR[I, 5]]), Format(s1,[COVAR[I, 6]]),
      Format(s1,[COVAR[I, 7]]), Format(s1,[COVAR[I, 8]]),
      Format(s1,[COVAR[I, 9]]), Format(s1,[COVAR[I, 10]]));
  //Test 2 - reverse
  Writeln(F,'Test #2 - Reverse');
  For I:= 1 To MA do
  begin
    For J:= 1 To MA do
    begin
      COVAR[I, J]:= 0;
      If (I <= 5) And (J <= 5) Then
        COVAR[I, J]:= I + J - 1;
    end;
  end;
  For I:= 1 To MFIT do
    LISTA[I]:= MFIT + 1 - I;
  COVSRT(COVAR, MA, MA, LISTA, MFIT);
  For I:= 1 To MA do
    Writeln(F, Format(s1,[COVAR[I, 1]]), Format(s1,[COVAR[I, 2]]),
      Format(s1,[COVAR[I, 3]]), Format(s1,[COVAR[I, 4]]),
      Format(s1,[COVAR[I, 5]]), Format(s1,[COVAR[I, 6]]),
      Format(s1,[COVAR[I, 7]]), Format(s1,[COVAR[I, 8]]),
      Format(s1,[COVAR[I, 9]]), Format(s1,[COVAR[I, 10]]));
  //Test 3 - spread and reverse
  Writeln(F,'Test #3 - Spread and reverse');
  For I:= 1 To MA do
  begin
    For J:= 1 To MA do
    begin
      COVAR[I, J]:= 0;
      If (I <= 5) And (J <= 5) Then
        COVAR[I, J]:= I + J - 1;
    end;
  end;
  For I:= 1 To MFIT do
    LISTA[I]:= MA + 2 - 2 * I;
  COVSRT(COVAR, MA, MA, LISTA, MFIT);
  For I:= 1 To MA do
    Writeln(F, Format(s1,[COVAR[I, 1]]), Format(s1,[COVAR[I, 2]]),
      Format(s1,[COVAR[I, 3]]), Format(s1,[COVAR[I, 4]]),
      Format(s1,[COVAR[I, 5]]), Format(s1,[COVAR[I, 6]]),
      Format(s1,[COVAR[I, 7]]), Format(s1,[COVAR[I, 8]]),
      Format(s1,[COVAR[I, 9]]), Format(s1,[COVAR[I, 10]]));
  CloseFile(F);
  //Ļʾ
  memo1.Lines.LoadFromFile('d:\delphi_shu\p7\d7r3.dat');
end;
end.
