unit Unit2;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;
Function PLGNDR(L, M:integer; X:real):real;
Procedure FLEG(X:real; var PL:array of real; NL:integer);

implementation
Function PLGNDR(L, M:integer; X:real):real;
var
    PMM,SOMX2,FACT,PMMP1,PLL:real;
    I,LL:integer;
begin
    If (M < 0) Or (M > L) Or (Abs(X) > 1) Then
        ShowMessage('bad arguments');
    PMM:=1;
    If M > 0 Then
      begin
        SOMX2:=Sqrt((1 - X) * (1 + X));
        FACT:=1;
        For I:=1 To M do
          begin
            PMM:=-PMM * FACT * SOMX2;
            FACT:=FACT + 2;
          end;
      end;
    If L = M Then
        PLGNDR:=PMM
    Else
      begin
        PMMP1:=X * (2 * M + 1) * PMM;
        If L = M + 1 Then
            PLGNDR:=PMMP1
        Else
          begin
            For LL:= M + 2 To L do
              begin
                PLL:=X * (2 * LL - 1) * PMMP1 - (LL + M - 1) * PMM;
                PLL:=PLL / (LL - M);
                PMM:=PMMP1;
                PMMP1:=PLL;
              end;
            PLGNDR:=PLL;
          end;
      end;
end;

Procedure FLEG(X:real; var PL:array of real; NL:integer);
var
    J:integer;  TWOX,F1,F2,D:real;
begin
    PL[1]:=1;
    PL[2]:=X;
    If NL > 2 Then
    begin
        TWOX:=2 * X;
        F2:=X;
        D:=1; 
        For J:=3 To NL do
        begin
            F1:=D;
            F2:=F2 + TWOX;
            D:=D + 1;
            PL[J]:=(F2 * PL[J - 1] - F1 * PL[J - 2]) / D;
        end;
    end;
end;
end.
