unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;
Function FUN(X:real):real;
type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
//PROGRAM D8R3
//Driver for routine ZBRAK
uses
  unit2;
  {$R *.DFM}
Function FUN(X:real):real;
begin
    FUN:= BESSJ0(X);
end;

procedure TForm1.Button1Click(Sender: TObject);
const
  s1='%11.4f';  s2='%9.4f';  s3='##';
  N = 100; NBMAX = 20; X1 = 1; X2 = 50;
var
  F:TextFile;   XB1,XB2:array[0..20] of real;
  I,NB:integer;
begin
  NB:=NBMAX;
  ZBRAK(X1,X2,N,XB1,XB2,NB);
  //ļ
  AssignFile(F, 'd:\delphi_shu\p8\d8r3.dat');
  Rewrite(F);
  Writeln(F, '  Bracketing for roots of BESSJ0:');
  Writeln(F);
  Writeln(F, '            Lower   upper     F(lower)    F(upper)');
  Writeln(F);
  For I:= 1 To NB do
    Writeln(F,'Root ',FormatFloat(s3,I),'  ',Format(s2,[XB1[I]]),
               Format(s2,[XB2[I]]),Format(s1,[BESSJ0(XB1[I])]),
               Format(s1,[BESSJ0(XB2[I])]));
  CloseFile(F);
  //Ļʾ
  memo1.Lines.LoadFromFile('d:\delphi_shu\p8\d8r3.dat');
end;

end.
