unit Unit2;

interface
Function ERFCC(X:real):real;

implementation
Function ERFCC(X:real):real;
var
  T,Z,ANS,AAA,BBB,CCC,DDD:REAL;
begin
  Z:=Abs(X);
  T:=1 / (1 + 0.5 * Z);
  DDD:=-0.82215223 + T * 0.17087277;
  AAA:=T * (-1.13520398 + T * (1.48851587 + T * DDD));
  BBB:=T * (-0.18628806 + T * (0.27886807 + AAA));
  CCC:=T * (0.37409196 + T * (0.09678418 + BBB));
  ANS:=T * Exp(-Z * Z - 1.26551223 + T * (1.00002368 + CCC));
  ERFCC:=ANS;
  If X < 0 Then ERFCC:=2 - ANS;
end;

end.
 