unit Unit2;

interface
Function EX(X:real):real;

implementation
Function EX(X:real):real;
const
    R1 = 0.00107857;       R2 = -0.00976004;
    R3 = 0.05519968;       R4 = -0.24991055;
    R5 = 0.99999193;       R6 = -0.57721566;
    T1 = 8.5733287401;     T2 = 18.059016973;
    T3 = 8.6347608925;     T4 = 0.2677737343;
    S1 = 9.5733223454;     S2 = 25.6329561486;
    S3 = 21.0996530827;    S4 = 3.9584969228;
var
    AAA,Y,W:REAL;
begin
    If X < 1 Then
    begin
        AAA:=(R1 * X + R2) * X + R3;
        EX:=((AAA * X + R4) * X + R5) * X + R6 - Ln(X);
    end
    Else
    begin
        Y:=(((X + T1) * X + T2) * X + T3) * X + T4;
        W:=(((X + S1) * X + S2) * X + S3) * X + S4;
        EX:=(Y / W) / (Exp(X) * X);
    end;
end;
end.
 