unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  NTERM:^integer;
implementation
//PROGRAM D5R1
//Driver for routine EULSUM
uses
  unit2;
  {$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  F:TextFile;   I,J,MVAL:Integer;
  X,SUM,XPOWER,TERM:real;
const
  s1='%14.6f'; s2='%6.2f';  s3='###';
  NVAL = 40;
begin
  New(NTERM);
  //ļ
  AssignFile(F, 'd:\delphi_shu\p5\d5r1.dat');
  Rewrite(F);
  Writeln(F, 'How many terms in polynomial?');
  //Input MVAL, between 1 and 40, MVAL=0 to end.
  MVAL:=20;
  Writeln(F,'MVAL = ',FormatFloat(s3,MVAL));
  If (MVAL<=0) Or (MVAL>NVAL) then EXIT;
  Writeln(F, '    x        Actual     polynomial');
  For I:= -8 To 8 do
  begin
      X:= I /10;
      SUM:=0;
      XPOWER:=-1;
      For J:=1 To MVAL do
      begin
          XPOWER:=-X*XPOWER;
          TERM:=XPOWER/J;
          EULSUM(SUM,TERM,J);
      end;
      Writeln(F,Format(s2,[x]),Format(s1,[Ln(1+x)]),Format(s1,[SUM]));
  end;
  CloseFile(F);
  //Ļʾ
  memo1.Lines.LoadFromFile('d:\delphi_shu\p5\d5r1.dat');
end;

end.
