unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;
type
  matrx2=array of array of real;
type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
//PROGRAM D6R2
//Driver for routine EIGSRT
uses
  unit2;
{$R *.DFM}
procedure TForm1.Button1Click(Sender: TObject);
const
  s1='%14.6f';  s2='###'; s3='%9.6f';
  NP = 3;
var
    D:array[0..3] of real;
    F:TextFile;   A,V:matrx2;
    I,J,NROT:integer; 
begin
  SetLength(A,4,4);
  SetLength(V,4,4);
  A[1, 1]:=1; A[1, 2]:=2; A[1, 3]:=3;
  A[2, 1]:=2; A[2, 2]:=2; A[2, 3]:=3;
  A[3, 1]:=3; A[3, 2]:=3; A[3, 3]:=3;
  JACOBI(A, NP, D, V, NROT);
  //ļ
  AssignFile(F, 'd:\delphi_shu\p6\d6r2.dat');
  Rewrite(F);
  Writeln(F, ' Unsorted Eigenvectors:');
  Writeln(F);
  For I:=1 To NP do
  begin
    Writeln(F,' Eigenvalue ',FormatFloat(s2,I),' = ',Format(s3,[D[I]]));
    Writeln(F, ' Eigenvectors:');
    Writeln(F,Format(s1,[V[1,I]]),Format(s1,[V[2,I]]),Format(s1,[V[3,I]]));
  end;
  Writeln(F);
  Writeln(F,'********** sorting **********');
  EIGSRT(D,V,NP);
  Writeln(F, ' Sorted Eigenvectors: ');
  For I:=1 To NP do
  begin
    Writeln(F);
    Writeln(F, ' Eigenvalue ',FormatFloat(s2,I),' = ',Format(s3,[D[I]]));
    Writeln(F, ' Eigenvector:');
    Writeln(F,Format(s1,[V[1,I]]),Format(s1,[V[2,I]]),
                                        Format(s1,[V[3,I]]));
  end;
  CloseFile(F);
  //Ļʾ
    memo1.Lines.LoadFromFile('d:\delphi_shu\p6\d6r2.dat');
end;

end.
