unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
TYPE
  matrx2=array of array of real;
var
  Form1: TForm1;
  ISET:^integer; GSET:^real;
implementation
//PROGRAM D7R4
//Driver for routine SVDFIT
uses
  unit2;
{$R *.DFM}
procedure TForm1.Button1Click(Sender: TObject);
const
  s1='%10.6f';
  NPT = 100; NPOL = 5; SPREAD = 0.02;
var
  CVM,U,V:matrx2;
  X,Y,SIG:ARRAY[0..100] of real; A,W:ARRAY[0..5] of real;
  I,MP,NP:integer;    CHISQ:real;
  F:TextFile;
begin
  SetLength(CVM,6,6);
  SetLength(U,101,6);
  SetLength(V,6,6);
  New(ISET); New(GSET);
  Iset^:=0; GSET^:=0;
  Randomize;
  //Polynomial fit
  MP:= NPT;
  NP:= NPOL;
  For I:= 1 To NPT do
  begin
    X[I]:= 0.02 * I;
    Y[I]:= 1 + X[I] * (2 + X[I] * (3 + X[I] * (4 + X[I] * 5)));
    Y[I]:= Y[I] + SPREAD * GASDEV;
    SIG[I]:= SPREAD;
  end;
  SVDFIT(X, Y, SIG, NPT, A, NPOL, U, V, W, MP, NP, CHISQ, 'FPOLY');
  SVDVAR(V, NPOL, NP, W, CVM, NPOL);
  //ļ
  AssignFile(F, 'd:\delphi_shu\p7\d7r4.dat');
  Rewrite(F);
  Writeln(F,'Polynomial fit');
  Writeln(F);
  For I:= 1 To NPOL do
    Writeln(F, Format(s1,[A[I]]),'  +-  ',format(s1,[Sqrt(CVM[I, I])]));
  Writeln(F);
  Writeln(F,'Chi-squared  ', Format(s1,[CHISQ]));
  SVDFIT(X, Y, SIG, NPT, A, NPOL, U, V, W, MP, NP, CHISQ, 'FLEG');
  SVDVAR(V, NPOL, NP, W, CVM, NPOL);
  Writeln(F);
  Writeln(F,'Legendre polynomial fit');
  For I:= 1 To NPOL do
    Writeln(F, Format(s1,[A[I]]),'  +-  ',format(s1,[Sqrt(CVM[I, I])]));
  Writeln(F);
  Writeln(F,'Chi-squared  ', Format(s1,[CHISQ]));
  CloseFile(F);
  //Ļʾ
  memo1.Lines.LoadFromFile('d:\delphi_shu\p7\d7r4.dat');
end;

end.
