unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
type
  matrx2=array of array of real;
var
  Form1: TForm1;

implementation
//PROGRAM D7R5
//Driver for routine SVDVAR
uses
  unit2;
{$R *.DFM}
procedure TForm1.Button1Click(Sender: TObject);
const
  s1='%11.6f'; s2='%13.6f';
  MP = 6; MA = 3;  NCVM = MA;
var
  W:array[0..6] of real;
  V,CVM,TRU:matrx2;
  I,J:integer;
  F:TextFile;
begin
  SetLength(V,7,7);
  SetLength(CVM,4,4);
  SetLength(TRU,4,4);
  W[1]:=0;  W[2]:=1;  W[3]:=2;
  W[4]:=3;  W[5]:=4;  W[6]:=5;
  TRU[1, 1]:=1.25; TRU[1, 2]:=2.5; TRU[1, 3]:=3.75;
  TRU[2, 1]:=2.5;  TRU[2, 2]:=5;   TRU[2, 3]:=7.5;
  TRU[3, 1]:=3.75; TRU[3, 2]:=7.5; TRU[3, 3]:=11.25;
  For J:=1 To MP do
    For I:=1 To MP do
      V[I, J]:=I;
  //ļ
  AssignFile(F, 'd:\delphi_shu\p7\d7r5.dat');
  Rewrite(F);
  Writeln(F, 'Matrix v ');
  Writeln(F);
  For I:=1 To MP do
  Writeln(F,Format(s1,[V[I,1]]),Format(s1,[V[I,2]]),Format(s1,[V[I,3]]),
            Format(s1,[V[I,4]]),Format(s1,[V[I,5]]),Format(s1,[V[I,6]]));
  Writeln(F);
  Writeln(F, 'Matrix W');
  Writeln(F);
  Writeln(F,Format(s1,[W[1]]),Format(s1,[W[2]]),Format(s1,[W[3]]),
            Format(s1,[W[4]]),Format(s1,[W[5]]),Format(s1,[W[6]]));
  Writeln(F);
  SVDVAR(V,MA,MP,W,CVM,NCVM);
  Writeln(F);
  Writeln(F, 'Covariance matrix from SVDVAR');
  Writeln(F);
  For I:=1 To MA do
  Writeln(F,Format(s2,[CVM[I,1]]),Format(s2,[CVM[I,2]]),
            Format(s2,[CVM[I,3]]));
  Writeln(F);
  Writeln(F, 'Expected covariance matrix ');
  Writeln(F);
  For I:=1 To MA do
  Writeln(F,Format(s2,[TRU[I,1]]),Format(s2,[TRU[I,2]]),
            Format(s2,[TRU[I,3]]));
  Writeln(F);
  CloseFile(F);
  //Ļʾ
  memo1.Lines.LoadFromFile('d:\delphi_shu\p7\d7r5.dat');
end;
end.
